import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.undo.*;
import javax.swing.event.*;
import java.util.Vector;

public class Ennistus extends JApplet implements ActionListener{
  static Vector ringid=new Vector();
  UndoManager ennistushaldur=new UndoManager();
  Button edasi=new Button(">");
  Button tagasi=new Button("<");

  public Ennistus(){
    getContentPane().add(tagasi, BorderLayout.WEST);
    getContentPane().add(edasi, BorderLayout.EAST);
    tagasi.addActionListener(this);
    edasi.addActionListener(this);
    addMouseListener(
      new MouseAdapter(){
        public void mousePressed(MouseEvent e){
          ennistushaldur.undoableEditHappened(new UndoableEditEvent(
            Ennistus.this, new LisatavRing(e.getX(), e.getY())
          ));
          repaint();
        }
      }
    );
  }

  public void paint(Graphics g){
    g.setColor(Color.white);
    g.fillRect(0, 0, getWidth(), getHeight());
    g.setColor(Color.black);
    for(int i=0; i<ringid.size(); i++){
      Point p=(Point)ringid.elementAt(i);
      g.drawOval(p.x-5, p.y-5, 10, 10);
    }
  }
  
  public void actionPerformed(ActionEvent e){
   try{
    if(e.getSource()==tagasi&&ennistushaldur.canUndo()){
      ennistushaldur.undo();
    }
    if(e.getSource()==edasi&&ennistushaldur.canRedo()){
      ennistushaldur.redo();
    }
   }catch(Exception ex){ex.printStackTrace();}
   repaint();
  }
  
  public static void main(String argumendid[]){
    JFrame f=new JFrame("Ennistamine");
    f.setSize(250, 200);
    f.setLocation(200, 100);
    f.getContentPane().add(new Ennistus());
    f.setVisible(true);
  }
}

class LisatavRing extends AbstractUndoableEdit{
  Point p;
  public LisatavRing(int x, int y){
    p=new Point(x, y);
    edasi();
  }
  
  void edasi(){
    Ennistus.ringid.add(p);  
  }
  
  public void redo(){
    super.redo();
    edasi();
  }
  
  public void undo(){
    super.undo();
    Ennistus.ringid.remove(p);
  }
}